---
title: Compiling an Existing C Module to WebAssembly
slug: WebAssembly/existing_C_to_wasm
tags:
  - C++
  - Compiling
  - Emscripten
  - WebAssembly
  - wasm
---
<p>{{WebAssemblySidebar}}</p>

<p class="summary">A core use-case for WebAssembly is to take the existing ecosystem of C libraries and allow developers to use them on the web.</p>

<p>These libraries often rely on C's standard library, an operating system, a file system and other things. Emscripten provides most of these features, although there are some <a href="https://emscripten.org/docs/porting/guidelines/api_limitations.html">limitations</a>.</p>

<p>As an example, let's compile an encoder for WebP to wasm. The source for the WebP codec is written in C and <a href="https://github.com/webmproject/libwebp">available on GitHub</a> as well as some extensive <a href="https://developers.google.com/speed/webp/docs/api">API documentation</a>. That's a pretty good starting point.</p>

<pre class="brush: bash">$ git clone https://github.com/webmproject/libwebp</pre>

<p>To start off simple, expose <code>WebPGetEncoderVersion()</code> from <code>encode.h</code> to JavaScript by writing a C file called <code>webp.c</code>:</p>

<pre class="brush: cpp">#include "emscripten.h"
#include "src/webp/encode.h"

EMSCRIPTEN_KEEPALIVE
int version() {
  return WebPGetEncoderVersion();
}</pre>

<p>This is a good simple program to test whether you can get the source code of libwebp to compile, as it doesn't require any parameters or complex data structures to invoke this function.</p>

<p>To compile this program, you need to tell the compiler where it can find libwebp's header files using the -I flag and also pass it all the C files of libwebp that it needs. A useful strategy is just gave it <strong>all</strong> the C files and relied on the compiler to strip out everything that was unnecessary. It seemed to work brilliantly:</p>

<pre class="brush: bash">$ emcc -O3 -s WASM=1 -s EXTRA_EXPORTED_RUNTIME_METHODS='["cwrap"]' \
    -I libwebp \
    webp.c \
    libwebp/src/{dec,dsp,demux,enc,mux,utils}/*.c</pre>

<div class="note">
<p><strong>Note:</strong> This strategy will not work with every C project. Many projects rely on autoconf/automake to generate system-specific code before compilation. Emscripten provides <code>emconfigure</code> and <code>emmake</code> to wrap these commands and inject the appropriate parameters. You can find more in the <a href="https://emscripten.org/docs/compiling/Building-Projects.html">Emscripten documentation</a>.</p>
</div>

<p>Now you only need some HTML and JavaScript to load your new module:</p>

<pre class="brush: html">&lt;script src="./a.out.js"&gt;&lt;/script&gt;
&lt;script&gt;
  Module.onRuntimeInitialized = async _ =&gt; {
    const api = {
      version: Module.cwrap('version', 'number', []),
    };
    console.log(api.version());
  };
&lt;/script&gt;</pre>

<p>And you will see the correct version number in the <a href="https://googlechrome.github.io/samples/webassembly/version.html">output</a>:</p>

<p><img alt="  Screenshot of the DevTools console showing the correct versionnumber." src="https://mdn.mozillademos.org/files/15913/version.png" style="border-style: solid; border-width: 1px;"></p>

<div class="note">
<p><strong>Note:</strong> libwebp returns the current version a.b.c as a hexadecimal number 0xabc. For example, v0.6.1 is encoded as 0x000601 = 1537.</p>
</div>

<h3 id="Get_an_image_from_JavaScript_into_Wasm">Get an image from JavaScript into Wasm</h3>

<p>Getting the encoder's version number is great, but encoding an actual image would be more impressive. How do we do that?</p>

<p>The first question you need to answer is: how do I get the image into wasm? Looking at the <a href="https://developers.google.com/speed/webp/docs/api#simple_encoding_api">encoding API of libwebp</a>, you'll find that it expects an array of bytes in RGB, RGBA, BGR or BGRA. Luckily, the Canvas API has {{domxref("CanvasRenderingContext2D.getImageData")}} — that gives you an {{jsxref("Uint8ClampedArray")}} containing the image data in RGBA:</p>

<pre class="brush: js"> async function loadImage(src) {
  // Load image
  const imgBlob = await fetch(src).then(resp =&gt; resp.blob());
  const img = await createImageBitmap(imgBlob);
  // Make canvas same size as image
  const canvas = document.createElement('canvas');
  canvas.width = img.width;
  canvas.height = img.height;
  // Draw image onto canvas
  const ctx = canvas.getContext('2d');
  ctx.drawImage(img, 0, 0);
  return ctx.getImageData(0, 0, img.width, img.height);
}</pre>

<p>Now it's "only" a matter of copying the data from JavaScript into wasm. For that, you need to expose two additional functions — one that allocates memory for the image inside wasm and one that frees it up again:</p>

<pre class="brush: cpp">#include &lt;stdlib.h&gt; // required for malloc definition

EMSCRIPTEN_KEEPALIVE
uint8_t* create_buffer(int width, int height) {
  return malloc(width * height * 4 * sizeof(uint8_t));
}

EMSCRIPTEN_KEEPALIVE
void destroy_buffer(uint8_t* p) {
  free(p);
}</pre>

<p>The <code>create_buffer()</code> function allocates a buffer for the RGBA image — hence 4 bytes per pixel. The pointer returned by <code>malloc()</code> is the address of the first memory cell of that buffer. When the pointer is returned to JavaScript land, it is treated as just a number. After exposing the function to JavaScript using cwrap, you can use that number to find the start of our buffer and copy the image data:</p>

<pre class="brush: js">const api = {
  version: Module.cwrap('version', 'number', []),
  create_buffer: Module.cwrap('create_buffer', 'number', ['number', 'number']),
  destroy_buffer: Module.cwrap('destroy_buffer', '', ['number']),
};

const image = await loadImage('./image.jpg');
const p = api.create_buffer(image.width, image.height);
Module.HEAP8.set(image.data, p);
// ... call encoder ...
api.destroy_buffer(p);</pre>

<h3 id="Encode_the_Image">Encode the Image</h3>

<p>The image is now available in wasm. It is time to call the WebP encoder to do its job. Looking at the <a href="https://developers.google.com/speed/webp/docs/api#simple_encoding_api">WebP documentation</a>, you'll find that <code>WebPEncodeRGBA</code> seems like a perfect fit. The function takes a pointer to the input image and its dimensions, as well as a quality option between 0 and 100. It also allocates an output buffer for us that we need to free using <code>WebPFree()</code> once we are done with the WebP image.</p>

<p>The result of the encoding operation is an output buffer and its length. Because functions in C can't have arrays as return types (unless you allocate memory dynamically), this example resorts to a static global array. This may not be clean C. In fact, it relies on wasm pointers being 32 bits wide. But this is a fair shortuct for keeping things simple:</p>

<pre class="brush: js">int result[2];
EMSCRIPTEN_KEEPALIVE
void encode(uint8_t* img_in, int width, int height, float quality) {
  uint8_t* img_out;
  size_t size;

  size = WebPEncodeRGBA(img_in, width, height, width * 4, quality, &amp;img_out);

  result[0] = (int)img_out;
  result[1] = size;
}

EMSCRIPTEN_KEEPALIVE
void free_result(uint8_t* result) {
  WebPFree(result);
}

EMSCRIPTEN_KEEPALIVE
int get_result_pointer() {
  return result[0];
}

EMSCRIPTEN_KEEPALIVE
int get_result_size() {
  return result[1];
}</pre>

<p>Now with all of that in place, you can call the encoding function, grab the pointer and image size, put it in a JavaScript buffer of your own, and release all the wasm buffers allocated in the process:</p>

<pre class="brush: js">api.encode(p, image.width, image.height, 100);
const resultPointer = api.get_result_pointer();
const resultSize = api.get_result_size();
const resultView = new Uint8Array(Module.HEAP8.buffer, resultPointer, resultSize);
const result = new Uint8Array(resultView);
api.free_result(resultPointer);</pre>

<div class="note">
<p><strong>Note:</strong> <code>new Uint8Array(someBuffer)</code> will create a new view onto the same memory chunk, while <code>new Uint8Array(someTypedArray)</code> will copy the data.</p>
</div>

<p>Depending on the size of your image, you might run into an error where wasm can't grow the memory enough to accommodate both the input and the output image:</p>

<p><img alt="
  Screenshot of the DevTools console showing an error." src="https://mdn.mozillademos.org/files/15922/error.png"></p>

<p>Luckily, the solution to this problem is in the error message. You just need to add <code>-s ALLOW_MEMORY_GROWTH=1</code> to your compilation command.</p>

<p>And there you have it. You have compiled a WebP encoder and transcoded a JPEG image to WebP. To prove that it worked, turn your result buffer into a blob and use it on an <code>&lt;img&gt;</code> element:</p>

<pre class="brush: js">const blob = new Blob([result], {type: 'image/webp'});
const blobURL = URL.createObjectURL(blob);
const img = document.createElement('img');
img.src = blobURL;
document.body.appendChild(img)
</pre>

<p>Behold, the glory of a new WebP image.</p>

<p><a href="https://googlechrome.github.io/samples/webassembly/image.html">Demo</a> | <a href="https://developers.google.com/web/updates/2018/03/emscripting-a-c-library">Original Article</a></p>

<p><img alt="DevTools network panel and the generated image." src="https://mdn.mozillademos.org/files/15914/result.jpg" style="border-style: solid; border-width: 1px;"></p>
